﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.31
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public BANano As BANano
	Private mycountries As UOENowGridTable
	Private myplayers As UOENowGridTable
	Private countries As List
	Private players As List
End Sub



Sub Initialize
	BANano.GetElement("#body").empty
	BANano.LoadLayout("#body","vConnected")
	BANano.GetElement("#body").SetStyle($"{"padding": "8px"}"$)
	
	RefreshCountries
	
	'define the master details
	mycountries.PrimaryKey = "id"
	mycountries.AddColumn("id","#",mycountries.COLUMN_TEXT, 56, False, mycountries.ALIGN_CENTER)
	mycountries.AddColumn("text","Name",mycountries.COLUMN_TEXT, 0, True, mycountries.ALIGN_LEFT)
	mycountries.AddColumn("population","Population",mycountries.COLUMN_TEXT,0,True,mycountries.ALIGN_RIGHT)
	mycountries.SetColumnRenderer("population", "PopulationRender")
	
	mycountries.AddColumn("checked","Checked?",mycountries.COLUMN_CHECKBOX,100,False,mycountries.ALIGN_CENTER)
	mycountries.SetDataSource(countries)
	mycountries.refresh
	
	'define players
	myplayers.PrimaryKey = "id"
	myplayers.AddColumn("id","#",myplayers.COLUMN_TEXT, 56, False, myplayers.ALIGN_CENTER)
	myplayers.AddColumn("Name","Name",myplayers.COLUMN_TEXT, 0, True, myplayers.ALIGN_LEFT)
	myplayers.AddColumn("CountryName","Country Name",myplayers.COLUMN_DROPDOWN,200,True,myplayers.ALIGN_LEFT)
	myplayers.AddColumn("PlaceOfBirth","Place of Birth",myplayers.COLUMN_TEXT, 0, True, myplayers.ALIGN_LEFT)
	myplayers.AddColumn("DateOfBirth","Date of Birth", myplayers.COLUMN_DATE,150,False,myplayers.ALIGN_CENTER)
	'set the column data format
	myplayers.SetColumnFormat("DateOfBirth","dd.mm.yyyy")
	'uoegrid.AddColumn("tmpl","Template", uoegrid.COLUMN_String,0,False,uoegrid.ALIGN_LEFT)
	myplayers.AddColumn("IsActive","Active?",myplayers.COLUMN_CHECKBOX,80,False,myplayers.ALIGN_CENTER)
	myplayers.refresh
End Sub

Sub RefreshCountries
	countries.Initialize
	'countries.Add(CreateMap("id":"1","text":"Asia","population":Null,"flagUrl":Null,"checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":"12","text":"Brazil","population":207350000,"flagUrl":"https://code.gijgo.com/flags/24/brazil.png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":"14","text":"Colombia","population":-49819638,"flagUrl":"https://code.gijgo.com/flags/24/colombia.png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":"15","text":"South Africa","population":Null,"flagUrl":Null,"checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":"16","text":"England","population":54786300,"flagUrl":"https://code.gijgo.com/flags/24/england.png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":"17","text":"Germany","population":-82175700,"flagUrl":"https://code.gijgo.com/flags/24/germany.png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":"18","text":"Bulgaria","population":7101859,"flagUrl":"https://code.gijgo.com/flags/24/bulgaria.png","checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":"19","text":"Poland","population":-38454576,"flagUrl":"https://code.gijgo.com/flags/24/poland.png","checked":False,"hasChildren":False))
End Sub

Sub RefreshPlayers
	'lets create the players records
	players.Initialize
	players.Add(CreateMap("id": "1", "Name": "Hristo Stoichkov", "PlaceOfBirth": "Plovdiv, Bulgaria","CountryID":"18","CountryName": "Bulgaria"))
	players.Add(CreateMap("id": "2", "Name": "Ronaldo Luis Nazario de Lima", "PlaceOfBirth": "Rio de Janeiro, Brazil", "CountryID":"12","CountryName": "Brazil"))
	players.Add(CreateMap("id": "3", "Name": "David Platt", "PlaceOfBirth": "Chadderton, Lancashire, England","CountryID":"16","CountryName": "England"))
	players.Add(CreateMap("id": "4", "Name": "Manuel Neuer", "PlaceOfBirth": "Gelsenkirchen, West Germany", "CountryID":"17", "CountryName": "Germany"))
	players.Add(CreateMap("id": "5", "Name": "James Rodríguez", "PlaceOfBirth": "Cúcuta, Colombia", "CountryID":"14", "CountryName": "Colombia"))
	players.Add(CreateMap("id": "6", "Name": "Dimitar Berbatov", "PlaceOfBirth": "Blagoevgrad, Bulgaria", "CountryID":"18", "CountryName": "Bulgaria"))
	players.Add(CreateMap("id": "7", "Name": "Robert Lewandowski", "PlaceOfBirth": "Warsaw, Poland", "CountryID":"19", "CountryName": "Poland"))
	players.Add(CreateMap("id": "8", "Name": "Mashy", "PlaceOfBirth": "East London, Eastern Cape", "CountryID":"15", "CountryName": "South Africa"))
End Sub

Sub mycountries_RowSelect (e As BANanoEvent, row As Object, id As String, record As Map)
	'we are selecting a country
	'get the latest list of players
	RefreshPlayers
	myplayers.autoLoad = False
	myplayers.AddParamater("CountryID",id)
	myplayers.SetDataSource(players)
	myplayers.refresh
End Sub


Sub mycountries_PopulationRender(value As Object, record As Map, cell As BANanoObject, displayEl As BANanoObject)
	'if the value is null, make zero
	If value = Null Then value = 0
	'create element from object
	Dim dl As BANanoElement = BANano.ToElement(displayEl)
	'update the value, reference to http://numeraljs.com
	Dim sResult As String = mycountries.NumeralFormat(value,"0 a")
	'update the text for the rc
	dl.SetText(sResult)
	'if value < 0 make red
	If value < 0 Then
		dl.SetStyle($"{"color":"red"}"$)
	Else
		dl.SetStyle($"{"color":"green"}"$)
	End If
End Sub