﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.31
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public BANano As BANano
	Private uoegrid As UOENowGridTable
	Public JQuery As BANanoObject
	Private dataSource As List
End Sub

Sub Initialize
	JQuery.Initialize("$")
	BANano.GetElement("#body").empty
	BANano.LoadLayout("#body","vGrid1")
	BANano.GetElement("#body").SetStyle($"{"padding": "8px"}"$)
	
	'define the columns
	uoegrid.PrimaryKey = "id"
	uoegrid.AddColumn("id","#",uoegrid.COLUMN_TEXT, 56, False, uoegrid.ALIGN_CENTER)
	uoegrid.AddColumn("Name","Name",uoegrid.COLUMN_TEXT, 0, True, uoegrid.ALIGN_LEFT)
	uoegrid.AddColumn("CountryName","Country Name",uoegrid.COLUMN_DROPDOWN,200,True,uoegrid.ALIGN_LEFT)
	uoegrid.AddColumn("PlaceOfBirth","Place of Birth",uoegrid.COLUMN_TEXT, 0, True, uoegrid.ALIGN_LEFT)
	'uoegrid.AddColumn("DateOfBirth","Date of Birth", uoegrid.COLUMN_DATE,150,False,uoegrid.ALIGN_CENTER)
	'uoegrid.SetColumnFormat("DateOfBirth","dd.mm.yyyy")
	
	uoegrid.AddColumn("DateOfBirth","Date/Time of Birth", uoegrid.COLUMN_DATETIME,200,False,uoegrid.ALIGN_CENTER)
	
	uoegrid.AddColumn("IsActive","Active?",uoegrid.COLUMN_CHECKBOX,80,False,uoegrid.ALIGN_CENTER)
	uoegrid.SetColumnEditors(Array("Name","PlaceOfBirth","DateOfBirth","IsActive","CountryName"))
	
	'define data source for countries, the name SHOULD BE 'text'
	Dim countries As List
	countries.Initialize
	countries.Add(CreateMap("id":18, "text": "Bulgaria"))
	countries.Add(CreateMap("id":12, "text": "Brazil"))
	countries.Add(CreateMap("id":16, "text": "England"))
	countries.Add(CreateMap("id":17, "text": "Germany"))
	countries.Add(CreateMap("id":19, "text": "Poland"))
	countries.Add(CreateMap("id":14, "text": "Colombia"))
	countries.Add(CreateMap("id":15, "text": "South Africa"))
	uoegrid.SetColumnDataSource("CountryName", countries, "id", "CountryID")
	
	'set data
	RefreshDataSource
	uoegrid.SetDataSource(dataSource).Refresh
End Sub

Sub RefreshDataSource
	'add the datasource
	dataSource.Initialize
	dataSource.Add(CreateMap("id": 1, "Name": "Hristo Stoichkov", "PlaceOfBirth": "Plovdiv, Bulgaria","DateOfBirth":"/Date(-122227200000)/","IsActive":False,"CountryID":18,"CountryName": "Bulgaria"))
	dataSource.Add(CreateMap("id": 2, "Name": "Ronaldo Luis Nazario de Lima", "PlaceOfBirth": "Rio de Janeiro, Brazil", "DateOfBirth":"/Date(211878000000)/","IsActive":False,"CountryID":12,"CountryName": "Brazil"))
	dataSource.Add(CreateMap("id": 3, "Name": "David Platt", "PlaceOfBirth": "Chadderton, Lancashire, England","DateOfBirth":"/Date(-112122000000)/","IsActive":False,"CountryID":16,"CountryName": "England"))
	dataSource.Add(CreateMap("id": 4, "Name": "Manuel Neuer", "PlaceOfBirth": "Gelsenkirchen, West Germany", "DateOfBirth":"/Date(512294400000)/", "IsActive":True, "CountryID":17, "CountryName": "Germany"))
	dataSource.Add(CreateMap("id": 5, "Name": "James Rodríguez", "PlaceOfBirth": "Cúcuta, Colombia", "IsActive":True, "CountryName": "Colombia","DateOfBirth":"/Date(349689600000)/","CountryID":14))
	dataSource.Add(CreateMap("id": 6, "Name": "Dimitar Berbatov", "PlaceOfBirth": "Blagoevgrad, Bulgaria", "IsActive":False, "CountryName": "Bulgaria","DateOfBirth":"/Date(349689600000)/","CountryID":18))
	dataSource.Add(CreateMap("id": 7, "Name": "Robert Lewandowski", "PlaceOfBirth": "Warsaw, Poland", "DateOfBirth":"/Date(588150000000)/", "CountryID":19, "CountryName": "Poland", "IsActive":True))
	dataSource.Add(CreateMap("id": 8, "Name": "Mashy", "PlaceOfBirth": "East London, Eastern Cape", "DateOfBirth":"/Date(588150000000)/", "CountryID":15, "CountryName": "South Africa", "IsActive":True))
End Sub

Sub uoegrid_CellDataChanged (e As BANanoEvent, cell As Object, column As Object, record As Map, newValue As String)
	'Log(cell)
	'Log(column)
	'Log(record)
	'Log(newValue)
End Sub

Sub uoegrid_RowDataChanged (e As BANanoEvent, id As String, record As Map)
	BANano.Alert(BANano.ToJson(record))
End Sub


Sub uoegrid_RowDataBound (e As BANanoEvent, row As Object, id As String, record As Map)
	'Log(record)
End Sub

Sub uoegrid_RowRemoving (e As BANanoEvent, row As Object, id As String, record As Map)
	'get the name
	Dim sname As String = record.Get("Name")
	'confirm, you can add your own custom confirm box here
	Dim res As Boolean = BANano.Window.Confirm($"Are you sure that you want to delete player ${sname}?"$)
	'if yes remove the record from the grid
	If res Then
		'delete record from db
	Else
		'read records from db and reload
		RefreshDataSource
		uoegrid.Refresh
	End If
End Sub