﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.31
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public BANano As BANano
	Private gridcountries As UOENowGridTable
	Private players As List
End Sub


Sub Initialize
	BANano.GetElement("#body").empty
	BANano.LoadLayout("#body","vCountries")
	BANano.GetElement("#body").SetStyle($"{"padding": "8px"}"$)
	
	'define the master details
	gridcountries.PrimaryKey = "id"
	gridcountries.AddColumn("id","#",gridcountries.COLUMN_TEXT, 56, False, gridcountries.ALIGN_CENTER)
	gridcountries.AddColumn("text","Name",gridcountries.COLUMN_TEXT, 0, True, gridcountries.ALIGN_LEFT)
	gridcountries.AddColumn("flagUrl","Flag",gridcountries.COLUMN_IMAGE, 0, True, gridcountries.ALIGN_LEFT)
	gridcountries.AddColumn("population","Population",gridcountries.COLUMN_FILESIZE,0,True,gridcountries.ALIGN_RIGHT)
	gridcountries.SetColumnFormatNumeral("population","0.0a")
	gridcountries.AddColumn("icon","",gridcountries.COLUMN_ICONRENDER,80,False,gridcountries.ALIGN_CENTER)
	gridcountries.SetColumnClickEvent("icon",True)
	
	Dim countries As List
	countries.Initialize
	'countries.Add(CreateMap("id":"1","text":"Asia","population":Null,"flagUrl":Null,"checked":False,"hasChildren":False))
	countries.Add(CreateMap("id":"12","text":"Brazil","population":207350000,"flagUrl":"https://code.gijgo.com/flags/24/brazil.png","checked":False,"hasChildren":False,"iconsize":"32","iconcolor":"red","icon":"fa fa-facebook-square", _
	"imagewidth":"42","imageheight":"42"))
	countries.Add(CreateMap("id":"14","text":"Colombia","population":49819638,"flagUrl":"https://code.gijgo.com/flags/24/colombia.png","checked":False,"hasChildren":False,"iconsize":"32","iconcolor":"green","icon":"fa fa-linkedin-square","imagewidth":"42","imageheight":"42"))
	countries.Add(CreateMap("id":"15","text":"South Africa","population":Null,"flagUrl":Null,"checked":False,"hasChildren":False,"iconsize":"32","iconcolor":"orange","icon":"fa fa fa-twitter-square","imagewidth":"40","imageheight":"42"))
	countries.Add(CreateMap("id":"16","text":"England","population":54786300,"flagUrl":"https://code.gijgo.com/flags/24/england.png","checked":False,"hasChildren":False,"iconsize":"32","iconcolor":"blue","icon":"fa fa-google-plus-square","imagewidth":"42","imageheight":"42"))
	countries.Add(CreateMap("id":"17","text":"Germany","population":82175700,"flagUrl":"https://code.gijgo.com/flags/24/germany.png","checked":False,"hasChildren":False,"iconsize":"32","iconcolor":"yelow","icon":"fa fa-pinterest-square","imagewidth":"42","imageheight":"42"))
	countries.Add(CreateMap("id":"18","text":"Bulgaria","population":7101859,"flagUrl":"https://code.gijgo.com/flags/24/bulgaria.png","checked":False,"hasChildren":False,"iconsize":"32","iconcolor":"red","icon":"fa fa-power-off","imagewidth":"42","imageheight":"42"))
	countries.Add(CreateMap("id":"19","text":"Poland","population":38454576,"flagUrl":"https://code.gijgo.com/flags/24/poland.png","checked":False,"hasChildren":False,"iconsize":"32","iconcolor":"olive","icon":"fa fa fa-users","imagewidth":"42","imageheight":"42"))
	gridcountries.SetDataSource(countries)
	'define the details grid to be nested
	gridcountries.DetailTemplate = "<div><table/></div>"
	gridcountries.refresh
End Sub

Sub gridcountries_icon(e As BANanoEvent)
	Dim record As Map = gridcountries.GetRecordFromEvent(e)
	BANano.Alert(BANano.ToJson(record))
End Sub

Sub RefreshPlayers
	'lets create the players records
	players.Initialize
	players.Add(CreateMap("id": "1", "Name": "Hristo Stoichkov", "PlaceOfBirth": "Plovdiv, Bulgaria","CountryID":"18","CountryName": "Bulgaria"))
	players.Add(CreateMap("id": "2", "Name": "Ronaldo Luis Nazario de Lima", "PlaceOfBirth": "Rio de Janeiro, Brazil", "CountryID":"12","CountryName": "Brazil"))
	players.Add(CreateMap("id": "3", "Name": "David Platt", "PlaceOfBirth": "Chadderton, Lancashire, England","CountryID":"16","CountryName": "England"))
	players.Add(CreateMap("id": "4", "Name": "Manuel Neuer", "PlaceOfBirth": "Gelsenkirchen, West Germany", "CountryID":"17", "CountryName": "Germany"))
	players.Add(CreateMap("id": "5", "Name": "James Rodríguez", "PlaceOfBirth": "Cúcuta, Colombia", "CountryID":"14", "CountryName": "Colombia"))
	players.Add(CreateMap("id": "6", "Name": "Dimitar Berbatov", "PlaceOfBirth": "Blagoevgrad, Bulgaria", "CountryID":"18", "CountryName": "Bulgaria"))
	players.Add(CreateMap("id": "7", "Name": "Robert Lewandowski", "PlaceOfBirth": "Warsaw, Poland", "CountryID":"19", "CountryName": "Poland"))
	players.Add(CreateMap("id": "8", "Name": "Mashy", "PlaceOfBirth": "East London, Eastern Cape", "CountryID":"15", "CountryName": "South Africa"))
End Sub


Sub gridcountries_DetailExpand (e As BANanoEvent, detailWrapper As BANanoObject, id As String)
	'get record
	Dim record As Map = gridcountries.GetById(id)
	RefreshPlayers
	'find the table in the detailedWrapper
	Dim dw As BANanoObject = detailWrapper.RunMethod("find",Array("table"))
	'destroy the grid, clear data and remove events
	dw.RunMethod("grid", Array("destroy",True,True))
	'define the filter
	Dim params As Map = CreateMap("CountryID":id)
	'define the pager
	Dim pager As Map = CreateMap("limit":5)
	'define the options
	Dim opt As Map
	opt.Initialize
	opt.Put("title", "Players")
	opt.Put("primaryKey", "id")
	opt.Put("autoLoad", True)
	opt.Put("uiLibrary", gridcountries.UILibrary)
	opt.Put("iconsLibrary", gridcountries.IconsLibrary)
	opt.Put("params", params)
	opt.Put("dataSource", players)
	opt.Put("autoGenerateColumns", True)
	opt.Put("pager", pager)
	'create the grid
	dw.RunMethod("grid", Array(opt))
	'Dim childGrid As BANanoObject = dw.RunMethod("grid", Array(opt))
	'childGrid.RunMethod("reload", Array(CreateMap("CountryID":id)))
End Sub

Sub gridcountries_DetailCollapse (e As BANanoEvent, detailWrapper As BANanoObject, id As String)
	'find the table in the detailedWrapper
	Dim dw As BANanoObject = detailWrapper.RunMethod("find",Array("table"))
	'destry the grid, clear data and remove events
	dw.RunMethod("grid", Array("destroy",True,True))
End Sub